diff -ur boost_1_33_1_ori/Jamfile boost_1_33_1/Jamfile
--- boost_1_33_1_ori/Jamfile	2005-11-08 05:39:45.000000000 +0100
+++ boost_1_33_1/Jamfile	2006-04-06 11:41:39.000000000 +0200
@@ -122,6 +122,7 @@
 # object code libraries
 local lib-locate = [ MATCH "^--libdir=(.*)" : $(ARGV) ] ;
 lib-locate ?= $(exec-locate)/lib ;
+gLIB_INSTALL_DIR ?= $(lib-locate) ;
 
 # where to build
 local all-locate = [ MATCH "^--builddir=(.*)" : $(ARGV) ] ;
diff -ur boost_1_33_1_ori/libs/python/build/Jamfile boost_1_33_1/libs/python/build/Jamfile
--- boost_1_33_1_ori/libs/python/build/Jamfile	2005-05-20 22:12:29.000000000 +0200
+++ boost_1_33_1/libs/python/build/Jamfile	2006-04-06 11:41:39.000000000 +0200
@@ -62,7 +62,7 @@
       <define>BOOST_PYTHON_SOURCE
       $(bpl-linkflags)
         <msvc-stlport><release>$(msvc-stlport-workarounds)
-        <darwin><*><linkflags>-bind_at_load
+        <darwin><*><linkflags>"-undefined dynamic_lookup -W,l-bind_at_load"
         <gcc-3_3-darwin><*><linkflags>-bind_at_load
       ;
 
diff -ur boost_1_33_1_ori/libs/test/build/Jamfile boost_1_33_1/libs/test/build/Jamfile
--- boost_1_33_1_ori/libs/test/build/Jamfile	2005-08-23 04:19:44.000000000 +0200
+++ boost_1_33_1/libs/test/build/Jamfile	2006-04-06 11:41:39.000000000 +0200
@@ -75,13 +75,16 @@
 if $(TEST_DLLs)
 {
 dll boost_prg_exec_monitor    : <template>boost_test_lib
-                                ../src/$(PRG_EXEC_MON_SOURCES).cpp ;
+                                ../src/$(PRG_EXEC_MON_SOURCES).cpp 
+                       : <darwin><*><linkflags>"-undefined dynamic_lookup" ;
 
 dll boost_test_exec_monitor   : <template>boost_test_lib
-                                ../src/$(TEST_EXEC_MON_SOURCES).cpp ; 
+                                ../src/$(TEST_EXEC_MON_SOURCES).cpp  
+                       : <darwin><*><linkflags>"-undefined dynamic_lookup" ;
 
 dll boost_unit_test_framework : <template>boost_test_lib
-                                ../src/$(UTF_SOURCES).cpp ;
+                                ../src/$(UTF_SOURCES).cpp 
+                       : <darwin><*><linkflags>"-undefined dynamic_lookup" ;
 }
 
 install test lib
diff -ur boost_1_33_1_ori/tools/build/v1/boost-base.jam boost_1_33_1/tools/build/v1/boost-base.jam
--- boost_1_33_1_ori/tools/build/v1/boost-base.jam	2005-10-20 00:34:04.000000000 +0200
+++ boost_1_33_1/tools/build/v1/boost-base.jam	2006-04-06 14:35:06.000000000 +0200
@@ -2618,7 +2618,6 @@
     if <threading>multi in $(properties) { thread-tag = mt ; }
     
     local runtime-tag = ;
-    if <runtime-link>static in $(properties) { runtime-tag += s ; }
     if <runtime-build>debug in $(properties) { runtime-tag += g ; }
     if [ MATCH .*(debug-python).* : $(variant) ] { runtime-tag += y ; }
     else { if [ MATCH .*(debug).* : $(variant) ] { runtime-tag += d ; } }
diff -ur boost_1_33_1_ori/tools/build/v1/darwin-tools.jam boost_1_33_1/tools/build/v1/darwin-tools.jam
--- boost_1_33_1_ori/tools/build/v1/darwin-tools.jam	2005-05-11 08:15:20.000000000 +0200
+++ boost_1_33_1/tools/build/v1/darwin-tools.jam	2006-04-06 14:42:45.000000000 +0200
@@ -187,7 +187,8 @@
     && \
     $(.GCC_BIN_DIR)$(.GXX) $(LINKFLAGS) -o "$(<[1])" "$(<[1]:S=.lo)" \
       -F$(FRAMEWORKS:D) -framework$(_)$(FRAMEWORKS:D=) \
-      -L"$(LIBPATH:T)" -L"$(STDLIBPATH:T)" "$(NEEDLIBS)" "$(NEEDLIBS)" -l$(FINDLIBS) -dynamiclib -install_name "$(<[1]:D=:S=.dylib)" \
+      -L"$(LIBPATH:T)" -L"$(STDLIBPATH:T)" "$(NEEDLIBS)" "$(NEEDLIBS)" -l$(FINDLIBS) -dynamiclib \
+      -install_name "$(<[1]:D=$(gLIB_INSTALL_DIR):S=.dylib)" -compatibility_version $(DLLVERSION) -current_version $(DLLVERSION) \
     && \
     rm -f "$(<[1]:S=.lo)"
 }
--- boost_1_33_1/tools/build/v1/python.jam~	2005-10-26 05:30:41.000000000 +0200
+++ boost_1_33_1/tools/build/v1/python.jam	2006-07-20 14:17:09.000000000 +0200
@@ -76,7 +76,7 @@
 
 	if $(OS) = MACOSX
 	{
-		PYTHON_EMBEDDED_LIBRARY = ;
+		PYTHON_EMBEDDED_LIBRARY = python$(PYTHON_VERSION) ;
 	}
 	else if $(OS) = SOLARIS
 	{
--- boost_1_33_1/tools/build/v1/gcc-tools.jam~	2005-11-19 20:21:16.000000000 +0100
+++ boost_1_33_1/tools/build/v1/gcc-tools.jam	2006-07-20 14:40:58.000000000 +0200
@@ -120,8 +120,8 @@
         # MacOS X, doesn't need any threading options set
         # -lpthread is linked to by default.
         # There is no gcc/g++, we need to use cc/c++ instead:
-        .GCC ?= cc ;
-        .GXX ?= c++ ;
+        #.GCC ?= cc ;
+        #.GXX ?= c++ ;
         }
     case *BSD :
         {
@@ -362,7 +362,17 @@
 }
 else
 {
-    flags gcc LINKFLAGS <target-type>$(SHARED_TYPES) : -shared ;
+    switch $(JAMUNAME)
+    {
+    case Darwin :
+        {
+        flags gcc LINKFLAGS <target-type>$(SHARED_TYPES) : -dynamiclib ;
+        }
+    case * :
+        {
+        flags gcc LINKFLAGS <target-type>$(SHARED_TYPES) : -shared ;
+        }
+    }
 }
 
 flags gcc LIBPATH <library-path> ;
